=== modified file 'ChangeLog'
--- ChangeLog	2006-08-20 14:01:33 +0000
+++ ChangeLog	2006-08-20 16:41:46 +0000
@@ -1,5 +1,10 @@
 2006-08-20  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
 
+    * po/olive-gtk.pot: generated new .pot file
+    * olive/frontend/gtk/bookmark.py: implemented Edit bookmark dialog
+    * cmenu.ui: added Edit item to left context menu
+    * olive.glade: added Edit bookmark dialog
+    * olive/frontend/gtk/__init__.py: added support for bookmark titles
     * olive/frontend/gtk/__init__.py: proper handling of permission denied cases
     * olive/backend/info.py: handle permission denied exception in is_branch()
     * olive/backend/fileops.py: handle permission denied exception in status()

=== modified file 'TODO'
--- TODO	2006-08-20 14:01:33 +0000
+++ TODO	2006-08-20 16:41:46 +0000
@@ -18,5 +18,5 @@
  - Implement bundle handling - at least creating them (phanatic)
 [DONE] Testing on Windows platform (phanatic)
 [DONE] i18n/l10n with gettext (phanatic)
- - Bookmarks should have a 'title' attribute (phanatic)
+[DONE] Bookmarks should have a 'title' attribute (phanatic)
 [PART-DONE] Open files on double-click, and add Open option to context menu (Aaadam)

=== modified file 'cmenu.ui'
--- cmenu.ui	2006-08-19 20:31:46 +0000
+++ cmenu.ui	2006-08-20 16:41:46 +0000
@@ -10,6 +10,7 @@
         <menuitem name="bookmark" action="bookmark" />
     </popup>
     <popup name="context_left">
+        <menuitem name="edit_bookmark" action="edit_bookmark" />
         <menuitem name="remove_bookmark" action="remove_bookmark" />
     </popup>
     <popup name="toolbar_diff">

=== modified file 'olive.glade'
--- olive.glade	2006-08-20 13:02:35 +0000
+++ olive.glade	2006-08-20 16:41:46 +0000
@@ -5164,4 +5164,186 @@
   </child>
 </widget>
 
+<widget class="GtkWindow" id="window_bookmark">
+  <property name="visible">True</property>
+  <property name="title" translatable="yes">Edit bookmark - Olive</property>
+  <property name="type">GTK_WINDOW_TOPLEVEL</property>
+  <property name="window_position">GTK_WIN_POS_NONE</property>
+  <property name="modal">False</property>
+  <property name="resizable">True</property>
+  <property name="destroy_with_parent">False</property>
+  <property name="icon">oliveicon2.png</property>
+  <property name="decorated">True</property>
+  <property name="skip_taskbar_hint">False</property>
+  <property name="skip_pager_hint">False</property>
+  <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
+  <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
+  <property name="focus_on_map">True</property>
+  <property name="urgency_hint">False</property>
+
+  <child>
+    <widget class="GtkVBox" id="vbox_bookmark">
+      <property name="border_width">5</property>
+      <property name="visible">True</property>
+      <property name="homogeneous">False</property>
+      <property name="spacing">3</property>
+
+      <child>
+	<widget class="GtkTable" id="table_bookmark">
+	  <property name="visible">True</property>
+	  <property name="n_rows">2</property>
+	  <property name="n_columns">2</property>
+	  <property name="homogeneous">False</property>
+	  <property name="row_spacing">3</property>
+	  <property name="column_spacing">3</property>
+
+	  <child>
+	    <widget class="GtkLabel" id="label_bookmark_location">
+	      <property name="visible">True</property>
+	      <property name="label" translatable="yes">Location:</property>
+	      <property name="use_underline">False</property>
+	      <property name="use_markup">False</property>
+	      <property name="justify">GTK_JUSTIFY_LEFT</property>
+	      <property name="wrap">False</property>
+	      <property name="selectable">False</property>
+	      <property name="xalign">0</property>
+	      <property name="yalign">0.5</property>
+	      <property name="xpad">0</property>
+	      <property name="ypad">0</property>
+	      <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+	      <property name="width_chars">-1</property>
+	      <property name="single_line_mode">False</property>
+	      <property name="angle">0</property>
+	    </widget>
+	    <packing>
+	      <property name="left_attach">0</property>
+	      <property name="right_attach">1</property>
+	      <property name="top_attach">0</property>
+	      <property name="bottom_attach">1</property>
+	      <property name="x_options">fill</property>
+	      <property name="y_options"></property>
+	    </packing>
+	  </child>
+
+	  <child>
+	    <widget class="GtkLabel" id="label_bookmark_title">
+	      <property name="visible">True</property>
+	      <property name="label" translatable="yes">Title:</property>
+	      <property name="use_underline">False</property>
+	      <property name="use_markup">False</property>
+	      <property name="justify">GTK_JUSTIFY_LEFT</property>
+	      <property name="wrap">False</property>
+	      <property name="selectable">False</property>
+	      <property name="xalign">0</property>
+	      <property name="yalign">0.5</property>
+	      <property name="xpad">0</property>
+	      <property name="ypad">0</property>
+	      <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+	      <property name="width_chars">-1</property>
+	      <property name="single_line_mode">False</property>
+	      <property name="angle">0</property>
+	    </widget>
+	    <packing>
+	      <property name="left_attach">0</property>
+	      <property name="right_attach">1</property>
+	      <property name="top_attach">1</property>
+	      <property name="bottom_attach">2</property>
+	      <property name="x_options">fill</property>
+	      <property name="y_options"></property>
+	    </packing>
+	  </child>
+
+	  <child>
+	    <widget class="GtkEntry" id="entry_bookmark_location">
+	      <property name="visible">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="editable">False</property>
+	      <property name="visibility">True</property>
+	      <property name="max_length">0</property>
+	      <property name="text" translatable="yes"></property>
+	      <property name="has_frame">True</property>
+	      <property name="invisible_char">●</property>
+	      <property name="activates_default">False</property>
+	    </widget>
+	    <packing>
+	      <property name="left_attach">1</property>
+	      <property name="right_attach">2</property>
+	      <property name="top_attach">0</property>
+	      <property name="bottom_attach">1</property>
+	      <property name="y_options"></property>
+	    </packing>
+	  </child>
+
+	  <child>
+	    <widget class="GtkEntry" id="entry_bookmark_title">
+	      <property name="visible">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="has_focus">True</property>
+	      <property name="editable">True</property>
+	      <property name="visibility">True</property>
+	      <property name="max_length">0</property>
+	      <property name="text" translatable="yes"></property>
+	      <property name="has_frame">True</property>
+	      <property name="invisible_char">●</property>
+	      <property name="activates_default">False</property>
+	    </widget>
+	    <packing>
+	      <property name="left_attach">1</property>
+	      <property name="right_attach">2</property>
+	      <property name="top_attach">1</property>
+	      <property name="bottom_attach">2</property>
+	      <property name="y_options"></property>
+	    </packing>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkHButtonBox" id="hbuttonbox_bookmark">
+	  <property name="visible">True</property>
+	  <property name="layout_style">GTK_BUTTONBOX_END</property>
+	  <property name="spacing">3</property>
+
+	  <child>
+	    <widget class="GtkButton" id="button_bookmark_cancel">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label">gtk-cancel</property>
+	      <property name="use_stock">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_bookmark_cancel_clicked" last_modification_time="Sun, 20 Aug 2006 15:11:23 GMT"/>
+	    </widget>
+	  </child>
+
+	  <child>
+	    <widget class="GtkButton" id="button_bookmark_save">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="has_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label">gtk-save</property>
+	      <property name="use_stock">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_bookmark_save_clicked" last_modification_time="Sun, 20 Aug 2006 15:11:19 GMT"/>
+	    </widget>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+    </widget>
+  </child>
+</widget>
+
 </glade-interface>

=== modified file 'olive/frontend/gtk/__init__.py'
--- olive/frontend/gtk/__init__.py	2006-08-20 14:01:33 +0000
+++ olive/frontend/gtk/__init__.py	2006-08-20 16:41:46 +0000
@@ -135,15 +135,16 @@
         self.comm.set_busy(self.treeview_left)
         
         # Create TreeStore
-        treestore = gtk.TreeStore(str)
+        treestore = gtk.TreeStore(str, str)
         
         # Get bookmarks
         bookmarks = self.comm.pref.get_bookmarks()
         
         # Add them to the TreeStore
-        titer = treestore.append(None, [_('Bookmarks')])
+        titer = treestore.append(None, [_('Bookmarks'), None])
         for item in bookmarks:
-            treestore.append(titer, [item])
+            title = self.comm.pref.get_bookmark_title(item)
+            treestore.append(titer, [title, item])
         
         # Create the column and add it to the TreeView
         self.treeview_left.set_model(treestore)
@@ -333,7 +334,7 @@
         if iter is None:
             return None
         else:
-            return model.get_value(iter, 0)
+            return model.get_value(iter, 1)
 
     def set_statusbar(self, message):
         """ Set the statusbar message. """
@@ -356,9 +357,10 @@
         bookmarks = self.pref.get_bookmarks()
         
         # Add them to the TreeStore
-        titer = treestore.append(None, [_('Bookmarks')])
+        titer = treestore.append(None, [_('Bookmarks'), None])
         for item in bookmarks:
-            treestore.append(titer, [item])
+            title = self.pref.get_bookmark_title(item)
+            treestore.append(titer, [title, item])
         
         # Add the TreeStore to the TreeView
         self.treeview_left.set_model(treestore)
@@ -573,6 +575,19 @@
         else:
             return True
 
+    def get_bookmark_title(self, path):
+        """ Get bookmark title. """
+        try:
+            ret = self.config.get(path, 'title')
+        except ConfigParser.NoOptionError:
+            ret = path
+        
+        return ret
+    
+    def set_bookmark_title(self, path, title):
+        """ Set bookmark title. """
+        self.config.set(path, 'title', title)
+    
     def remove_bookmark(self, path):
         """ Remove bookmark. """
         return self.config.remove_section(path)

=== added file 'olive/frontend/gtk/bookmark.py'
--- olive/frontend/gtk/bookmark.py	1970-01-01 00:00:00 +0000
+++ olive/frontend/gtk/bookmark.py	2006-08-20 16:41:46 +0000
@@ -0,0 +1,75 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import sys
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+try:
+    import gtk
+    import gtk.glade
+except:
+    sys.exit(1)
+
+class OliveBookmark:
+    """ Display the Edit bookmark dialog and perform the needed actions. """
+    def __init__(self, gladefile, comm, dialog):
+        """ Initialize the Edit bookmark dialog. """
+        self.gladefile = gladefile
+        self.glade = gtk.glade.XML(self.gladefile, 'window_bookmark', 'olive-gtk')
+        
+        # Communication object
+        self.comm = comm
+        # Dialog object
+        self.dialog = dialog
+        
+        self.window = self.glade.get_widget('window_bookmark')
+        
+        # Dictionary for signal_autoconnect
+        dic = { "on_button_bookmark_save_clicked": self.bookmark,
+                "on_button_bookmark_cancel_clicked": self.close }
+        
+        # Connect the signals to the handlers
+        self.glade.signal_autoconnect(dic)
+        
+        # Get some important widgets
+        self.entry_location = self.glade.get_widget('entry_bookmark_location')
+        self.entry_title = self.glade.get_widget('entry_bookmark_title')
+
+    def display(self):
+        """ Display the Edit bookmark dialog. """
+        path = self.comm.get_selected_left()
+        self.entry_location.set_text(path)
+        self.entry_title.set_text(self.comm.pref.get_bookmark_title(path))
+        self.window.show_all()
+        
+    def bookmark(self, widget):
+        if self.entry_title.get_text() == '':
+            self.dialog.error_dialog(_('No title given'),
+                                     _('Please specify a title to continue.'))
+            return
+        
+        self.comm.pref.set_bookmark_title(self.entry_location.get_text(),
+                                          self.entry_title.get_text())
+        
+        self.close()
+        self.comm.refresh_left()
+    
+    def close(self, widget=None):
+        self.window.destroy()

=== modified file 'olive/frontend/gtk/menu.py'
--- olive/frontend/gtk/menu.py	2006-08-20 13:02:35 +0000
+++ olive/frontend/gtk/menu.py	2006-08-20 16:41:46 +0000
@@ -77,6 +77,10 @@
                                        _('Bookmark'), None,
                                        _('Bookmark current location'),
                                        self.bookmark),
+                                      ('edit_bookmark', gtk.STOCK_EDIT,
+                                       _('Edit'), None,
+                                       _('Edit the selected bookmark'),
+                                       self.edit_bookmark),
                                       ('remove_bookmark', gtk.STOCK_REMOVE,
                                        _('Remove'), None,
                                        _('Remove the selected bookmark'),
@@ -189,6 +193,12 @@
         
         self.comm.refresh_left()
 
+    def edit_bookmark(self, action):
+        """ Left context menu -> Edit """
+        from bookmark import OliveBookmark
+        bookmark = OliveBookmark(self.gladefile, self.comm, self.dialog)
+        bookmark.display()
+
     def remove_bookmark(self, action):
         """ Left context menu -> Remove """
         self.comm.pref.remove_bookmark(self.comm.get_selected_left())

=== modified file 'po/olive-gtk.pot'
--- po/olive-gtk.pot	2006-08-20 13:02:35 +0000
+++ po/olive-gtk.pot	2006-08-20 16:41:46 +0000
@@ -8,7 +8,7 @@
 msgstr ""
 "Project-Id-Version: PACKAGE VERSION\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2006-08-20 13:47+0200\n"
+"POT-Creation-Date: 2006-08-20 18:38+0200\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
@@ -133,7 +133,7 @@
 msgid "Log"
 msgstr ""
 
-#: olive.glade:479 commit.py:120 menu.py:69
+#: olive.glade:479 commit.py:118 menu.py:69
 msgid "Commit"
 msgstr ""
 
@@ -381,7 +381,7 @@
 msgid "(none)"
 msgstr ""
 
-#: olive.glade:3394
+#: olive.glade:3394 olive.glade:5203
 msgid "Location:"
 msgstr ""
 
@@ -517,28 +517,44 @@
 msgid "Revision store:"
 msgstr ""
 
-#: add.py:70 menu.py:128 menu.py:150 move.py:69 remove.py:70 rename.py:67
+#: olive.glade:5169
+msgid "Edit bookmark - Olive"
+msgstr ""
+
+#: olive.glade:5231
+msgid "Title:"
+msgstr ""
+
+#: add.py:70 menu.py:132 menu.py:154 move.py:69 remove.py:70 rename.py:67
 msgid "No file was selected"
 msgstr ""
 
-#: add.py:71 menu.py:129 menu.py:151 remove.py:71
+#: add.py:71 menu.py:133 menu.py:155 remove.py:71
 msgid ""
 "Please select a file from the list,\n"
 "or choose the other option."
 msgstr ""
 
-#: add.py:77 add.py:88 commit.py:97 commit.py:173 diff.py:106 handler.py:82
-#: info.py:485 log.py:63 menu.py:135 menu.py:157 push.py:79 push.py:122
+#: add.py:77 add.py:88 commit.py:96 commit.py:171 diff.py:106 handler.py:82
+#: info.py:485 log.py:63 menu.py:139 menu.py:161 push.py:79 push.py:122
 #: push.py:152 remove.py:77 remove.py:93 status.py:139
 msgid "Directory is not a branch"
 msgstr ""
 
-#: add.py:78 add.py:89 commit.py:98 commit.py:174 diff.py:107 handler.py:83
-#: info.py:486 log.py:64 menu.py:136 menu.py:158 push.py:80 push.py:123
+#: add.py:78 add.py:89 commit.py:97 commit.py:172 diff.py:107 handler.py:83
+#: info.py:486 log.py:64 menu.py:140 menu.py:162 push.py:80 push.py:123
 #: push.py:153 remove.py:78 remove.py:94 status.py:140
 msgid "You can perform this action only in a branch."
 msgstr ""
 
+#: bookmark.py:64
+msgid "No title given"
+msgstr ""
+
+#: bookmark.py:65
+msgid "Please specify a title to continue."
+msgstr ""
+
 #: branch.py:66 checkout.py:66
 msgid "Missing branch location"
 msgstr ""
@@ -605,69 +621,69 @@
 msgid "%d revision(s) branched."
 msgstr ""
 
+#: commit.py:120
+msgid "Path"
+msgstr ""
+
 #: commit.py:122
-msgid "Path"
-msgstr ""
-
-#: commit.py:124
 msgid "Type"
 msgstr ""
 
-#: commit.py:128 __init__.py:200
+#: commit.py:126 __init__.py:206 __init__.py:422
 msgid "added"
 msgstr ""
 
-#: commit.py:131 __init__.py:198
+#: commit.py:129 __init__.py:204 __init__.py:420
 msgid "removed"
 msgstr ""
 
-#: commit.py:134 __init__.py:196
+#: commit.py:132 __init__.py:202 __init__.py:418
 msgid "renamed"
 msgstr ""
 
-#: commit.py:137 __init__.py:202
+#: commit.py:135 __init__.py:208 __init__.py:424
 msgid "modified"
 msgstr ""
 
-#: commit.py:178
+#: commit.py:176
 msgid "Directory is not a checkout"
 msgstr ""
 
-#: commit.py:179
+#: commit.py:177
 msgid "You can perform local commit only on checkouts."
 msgstr ""
 
-#: commit.py:183
+#: commit.py:181
 msgid "No changes to commit"
 msgstr ""
 
-#: commit.py:184
+#: commit.py:182
 msgid "Try force commit if you want to commit anyway."
 msgstr ""
 
-#: commit.py:188
+#: commit.py:186
 msgid "Conflicts in tree"
 msgstr ""
 
-#: commit.py:189
+#: commit.py:187
 msgid "You need to resolve the conflicts before committing."
 msgstr ""
 
-#: commit.py:193
+#: commit.py:191
 msgid "Strict commit failed"
 msgstr ""
 
-#: commit.py:194
+#: commit.py:192
 msgid ""
 "There are unknown files in the working tree.\n"
 "Please add or delete them."
 msgstr ""
 
-#: commit.py:198
+#: commit.py:196
 msgid "Bound branch is out of date"
 msgstr ""
 
-#: commit.py:199
+#: commit.py:197
 #, python-format
 msgid "%s"
 msgstr ""
@@ -747,31 +763,31 @@
 msgid "This feature is not yet implemented."
 msgstr ""
 
-#: __init__.py:57
+#: __init__.py:58
 msgid "Glade file cannot be found."
 msgstr ""
 
-#: __init__.py:143
+#: __init__.py:144 __init__.py:360
 msgid "Bookmarks"
 msgstr ""
 
-#: __init__.py:149 menu.py:77
+#: __init__.py:151 menu.py:77
 msgid "Bookmark"
 msgstr ""
 
-#: __init__.py:204
+#: __init__.py:210 __init__.py:426
 msgid "unchanged"
 msgstr ""
 
-#: __init__.py:206
+#: __init__.py:212 __init__.py:428
 msgid "unknown"
 msgstr ""
 
-#: __init__.py:211
+#: __init__.py:217
 msgid "Filename"
 msgstr ""
 
-#: __init__.py:212
+#: __init__.py:218
 msgid "Status"
 msgstr ""
 
@@ -787,7 +803,7 @@
 msgid "Add the selected file"
 msgstr ""
 
-#: menu.py:65 menu.py:81
+#: menu.py:65 menu.py:85
 msgid "Remove"
 msgstr ""
 
@@ -807,49 +823,57 @@
 msgid "Bookmark current location"
 msgstr ""
 
+#: menu.py:81
+msgid "Edit"
+msgstr ""
+
 #: menu.py:82
+msgid "Edit the selected bookmark"
+msgstr ""
+
+#: menu.py:86
 msgid "Remove the selected bookmark"
 msgstr ""
 
-#: menu.py:85
+#: menu.py:89
 msgid "Selected..."
 msgstr ""
 
-#: menu.py:86
+#: menu.py:90
 msgid "Show the differences of the selected file"
 msgstr ""
 
-#: menu.py:89
+#: menu.py:93
 msgid "All..."
 msgstr ""
 
-#: menu.py:90
+#: menu.py:94
 msgid "Show the differences of all files"
 msgstr ""
 
-#: menu.py:161 remove.py:82
+#: menu.py:165 remove.py:82
 msgid "File not versioned"
 msgstr ""
 
-#: menu.py:162 remove.py:83
+#: menu.py:166 remove.py:83
 msgid "The selected file is not versioned."
 msgstr ""
 
-#: menu.py:184
+#: menu.py:188
 msgid "Bookmark successfully added"
 msgstr ""
 
-#: menu.py:185
+#: menu.py:189
 msgid ""
 "The current directory was bookmarked. You can reach\n"
 "it by selecting it from the left panel."
 msgstr ""
 
-#: menu.py:187
+#: menu.py:191
 msgid "Location already bookmarked"
 msgstr ""
 
-#: menu.py:188
+#: menu.py:192
 msgid ""
 "The current directory is already bookmarked.\n"
 "See the left panel for reference."

